import React from 'react';
import { useDayPicker } from '../../hooks';
import { UIElement as UI } from '../../types';
/**
 * Render the week number element. If `onWeekNumberClick` is passed to DayPicker, it
 * renders a button, otherwise a span element.
 */
export function WeekNumber(props) {
    var weekNumber = props.number, dates = props.dates;
    var _a = useDayPicker(), styles = _a.styles, classNames = _a.classNames, locale = _a.locale, weekNumberLabel = _a.labels.weekNumberLabel, formatWeekNumber = _a.formatters.formatWeekNumber, onWeekNumberClick = _a.onWeekNumberClick;
    var label = weekNumberLabel(Number(weekNumber), { locale: locale });
    var handleClick = function (e) {
        onWeekNumberClick === null || onWeekNumberClick === void 0 ? void 0 : onWeekNumberClick(weekNumber, dates, e);
    };
    var Component = onWeekNumberClick ? 'button' : 'span';
    return (React.createElement(Component, { "aria-label": label, className: classNames === null || classNames === void 0 ? void 0 : classNames[UI.WeekNumber], style: styles === null || styles === void 0 ? void 0 : styles[UI.WeekNumber], onClick: handleClick }, formatWeekNumber(Number(weekNumber), { locale: locale })));
}
//# sourceMappingURL=WeekNumber.js.map